# CalcOrders

Order system order management

## GET /v3/calc/orders

> Get all order IDs (and meta data) from your cart

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcOrderMeta":{"type":"object","required":["id","finalized","instantDeliverable"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"True if an order has been added to the cart."},"instantDeliverable":{"type":"boolean","description":"Whether this order is instantly deliverable (normally speaking)"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders":{"get":{"tags":["CalcOrders"],"summary":"Get all order IDs (and meta data) from your cart","operationId":"getCalcOrders","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderMeta"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/calc/orders

> Create an order from a config (tag)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcOrderCreate":{"type":"object","required":["configTag","couponTag","instantFinalize"],"properties":{"configTag":{"type":"string","format":"","description":"Configuration tag to create an order from."},"couponTag":{"type":"string","format":"","description":"Coupon tag to apply to the order."},"instantFinalize":{"type":"boolean","description":"Whether you want to immediately make the order available for checkout."}},"additionalProperties":false},"CalcOrder":{"type":"object","required":["id","finalized","createdAt","modifiedAt","quantity","title","categoryId","categoryName","configTag","configName","configFlags","instantDeliverable","price","setup","vat","vatPercentage","items"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"Whether the order has been added to your cart."},"createdAt":{"type":"integer","format":"integer","description":"Order creation unix timestamp"},"modifiedAt":{"type":"integer","format":"integer","description":"Order last modification unix timestamp"},"quantity":{"type":"integer","format":"integer","description":"Order quantity multiplier"},"title":{"type":"string","format":"","description":"Order title"},"categoryId":{"type":"integer","format":"integer","description":"Order shop category ID"},"categoryName":{"type":"string","format":"","description":"Order shop category name"},"configTag":{"type":"string","format":"","description":"The tag of the configuration this order is based upon."},"configName":{"type":"string","format":"","description":"The name of the configuration this order is based upon."},"configFlags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"price":{"type":"integer","format":"integer","description":"Order price in cents"},"setup":{"type":"integer","format":"integer","description":"Order setup price in cents"},"vat":{"type":"integer","format":"integer","description":"Order VAT in cents"},"vatPercentage":{"type":"number","format":"float","description":"Order VAT percentage"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"All items and quantities in the order"}},"additionalProperties":false},"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders":{"post":{"tags":["CalcOrders"],"summary":"Create an order from a config (tag)","operationId":"createCalcOrder","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrderCreate"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrder"}}}},"403":{"description":"Invalid credentials"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/calc/orders/quote

> Submit a quote request for your current cart

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcOrderQuote":{"type":"object","required":["firstName","lastName","email","phone"],"properties":{"userId":{"type":"integer","format":"integer","description":"Customer's user ID"},"firstName":{"type":"string","minLength":2,"maxLength":64,"format":"","description":"Customer's first name"},"lastName":{"type":"string","minLength":2,"maxLength":128,"format":"","description":"Customer's last name"},"companyName":{"type":"string","maxLength":120,"format":"","description":"Customer's company name (optional)"},"email":{"type":"string","maxLength":128,"format":"","description":"Customer's email address"},"phone":{"type":"string","minLength":5,"maxLength":15,"format":"","description":"Customer's phone number"},"remarks":{"type":"string","maxLength":4000,"format":"","description":"Remarks contain specific question(s) regarding the quote"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders/quote":{"post":{"tags":["CalcOrders"],"summary":"Submit a quote request for your current cart","operationId":"createCalcOrdersQuote","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrderQuote"}}},"required":true},"responses":{"200":{"description":"OK"},"403":{"description":"Invalid credentials"},"404":{"description":"If your cart is completely empty"},"422":{"description":"If you have an error in the submitted values"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/calc/orders/{orderId}

> Get an order from the cart

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcOrder":{"type":"object","required":["id","finalized","createdAt","modifiedAt","quantity","title","categoryId","categoryName","configTag","configName","configFlags","instantDeliverable","price","setup","vat","vatPercentage","items"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"Whether the order has been added to your cart."},"createdAt":{"type":"integer","format":"integer","description":"Order creation unix timestamp"},"modifiedAt":{"type":"integer","format":"integer","description":"Order last modification unix timestamp"},"quantity":{"type":"integer","format":"integer","description":"Order quantity multiplier"},"title":{"type":"string","format":"","description":"Order title"},"categoryId":{"type":"integer","format":"integer","description":"Order shop category ID"},"categoryName":{"type":"string","format":"","description":"Order shop category name"},"configTag":{"type":"string","format":"","description":"The tag of the configuration this order is based upon."},"configName":{"type":"string","format":"","description":"The name of the configuration this order is based upon."},"configFlags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"price":{"type":"integer","format":"integer","description":"Order price in cents"},"setup":{"type":"integer","format":"integer","description":"Order setup price in cents"},"vat":{"type":"integer","format":"integer","description":"Order VAT in cents"},"vatPercentage":{"type":"number","format":"float","description":"Order VAT percentage"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"All items and quantities in the order"}},"additionalProperties":false},"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders/{orderId}":{"get":{"tags":["CalcOrders"],"summary":"Get an order from the cart","operationId":"getCalcOrder","parameters":[{"name":"orderId","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrder"}}}},"403":{"description":"Invalid credentials"},"404":{"description":"If the order was not found"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/calc/orders/{orderId}

> Update an order

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcOrderUpdate":{"type":"object","required":["quantity","items"],"properties":{"quantity":{"type":"integer","format":"integer","description":"Order quantity"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"Order items"}},"additionalProperties":false},"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false},"CalcOrder":{"type":"object","required":["id","finalized","createdAt","modifiedAt","quantity","title","categoryId","categoryName","configTag","configName","configFlags","instantDeliverable","price","setup","vat","vatPercentage","items"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"Whether the order has been added to your cart."},"createdAt":{"type":"integer","format":"integer","description":"Order creation unix timestamp"},"modifiedAt":{"type":"integer","format":"integer","description":"Order last modification unix timestamp"},"quantity":{"type":"integer","format":"integer","description":"Order quantity multiplier"},"title":{"type":"string","format":"","description":"Order title"},"categoryId":{"type":"integer","format":"integer","description":"Order shop category ID"},"categoryName":{"type":"string","format":"","description":"Order shop category name"},"configTag":{"type":"string","format":"","description":"The tag of the configuration this order is based upon."},"configName":{"type":"string","format":"","description":"The name of the configuration this order is based upon."},"configFlags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"price":{"type":"integer","format":"integer","description":"Order price in cents"},"setup":{"type":"integer","format":"integer","description":"Order setup price in cents"},"vat":{"type":"integer","format":"integer","description":"Order VAT in cents"},"vatPercentage":{"type":"number","format":"float","description":"Order VAT percentage"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"All items and quantities in the order"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders/{orderId}":{"put":{"tags":["CalcOrders"],"summary":"Update an order","operationId":"updateCalcOrder","parameters":[{"name":"orderId","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"description":"Order quantity and items. Item groups must match those listed in the original configuration.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrderUpdate"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CalcOrder"}}}},"403":{"description":"Invalid credentials"},"404":{"description":"If the order was not found"},"422":{"description":"If you have an error in the submitted order values"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## DELETE /v3/calc/orders/{orderId}

> Delete an order from the cart

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders/{orderId}":{"delete":{"tags":["CalcOrders"],"summary":"Delete an order from the cart","operationId":"deleteCalcOrder","parameters":[{"name":"orderId","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"If the order was not found"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/calc/orders/finalize/{orderId}

> Set an order in the cart to "checkout" (which means it will show up on the checkout page). Updating the order is still allowed after finalization

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcOrders","description":"Order system order management"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/orders/finalize/{orderId}":{"put":{"tags":["CalcOrders"],"summary":"Set an order in the cart to \"checkout\" (which means it will show up on the checkout page). Updating the order is still allowed after finalization","operationId":"finalizeCalcOrder","parameters":[{"name":"orderId","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"If the order was not found"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.i3d.net/api-references/general/calcorders.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
